﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Kresleni
{
    public partial class Form1 : Form
    {
        private Pen pen = new Pen (Color.Red);
        private SolidBrush brush = new SolidBrush(Color.Green);

        public Form1()
        {
            InitializeComponent();

            plocha_Resize(null, null);
            /*
            plocha.Image = new Bitmap (400, 200);
            Graphics g = Graphics.FromImage(plocha.Image);
            g.FillRectangle(Brushes.White, 
                0, 0, plocha.Image.Width - 1, plocha.Image.Height - 1);
            */

            comboBox1.SelectedIndex = (int) (pen.Width - 1);

            propertyGrid1.SelectedObject = pen;
            selector.SelectedIndex = 0;

        }

        private void runToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Graphics g = Graphics.FromImage (plocha.Image);
            g.DrawLine(pen, 0, 0, 100, 100);
            plocha.Invalidate();
        }

        int x0, y0;

        private void plocha_MouseDown(object sender, MouseEventArgs e)
        {
            x0 = e.X;
            y0 = e.Y;
        }

        private void plocha_MouseUp(object sender, MouseEventArgs e)
        {
            Graphics g = Graphics.FromImage(plocha.Image);
            if (e.Button == MouseButtons.Left)
            {
                g.FillEllipse(brush, x0, y0, e.X - x0, e.Y - y0);
                g.DrawEllipse(pen, x0, y0, e.X - x0, e.Y - y0);
            }
            else if (e.Button == MouseButtons.Right)
            {
                g.DrawRectangle(pen, x0, y0, e.X - x0, e.Y - y0);
                g.FillRectangle(brush, x0, y0, e.X - x0, e.Y - y0);
            }
            else if (e.Button == MouseButtons.Middle)
            {
                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    Bitmap t = new Bitmap(openFileDialog1.FileName);
                    g.DrawImage(t, x0, y0, e.X - x0, e.Y - y0);
                }
            }
            plocha.Invalidate();
        }

        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            ToolStripButton b = (ToolStripButton) sender;
            pen.Color = b.BackColor;
        }

        private void zmenaBarvy(object sender, MouseEventArgs e)
        {

            ToolStripButton b = (ToolStripButton) sender;
            if (e.Button == MouseButtons.Left)
               pen.Color = b.BackColor;
            else if (e.Button == MouseButtons.Right)
               brush.Color = b.BackColor;
            else if (e.Button == MouseButtons.Middle)
            {
                colorDialog1.Color = b.BackColor;
                if (colorDialog1.ShowDialog () == DialogResult.OK)
                    b.BackColor = colorDialog1.Color;
            }

        }

        private void toolStripButton7_Click(object sender, EventArgs e)
        {
            pen.Width = 1;
        }

        private void toolStripButton6_Click(object sender, EventArgs e)
        {
            pen.Width = 2;

        }

        private void toolStripButton5_Click(object sender, EventArgs e)
        {
            pen.Width = 3;

        }

        private void toolStripButton7_Click_1(object sender, EventArgs e)
        {

        }

        private void toolStripButton7_Click_2(object sender, EventArgs e)
        {

        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            int n = comboBox1.SelectedIndex + 1;
            if (n >= 1)
                pen.Width = n;
        }

        private void selector_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (selector.SelectedIndex == 0)
                propertyGrid1.SelectedObject = pen;
            else if (selector.SelectedIndex == 1)
                propertyGrid1.SelectedObject = brush;

        }

        private void plocha_Resize(object sender, EventArgs e)
        {
            if (plocha.Size.Width > 0 && plocha.Size.Height > 0)
            {
                // plocha.Width = splitContainer1.Panel1.Width;
                // plocha.Height = splitContainer1.Panel1.Height;

                Bitmap b = new Bitmap(plocha.Size.Width, plocha.Size.Height);

                Graphics g = Graphics.FromImage(b);

                g.FillRectangle(Brushes.CornflowerBlue,
                    0, 0, plocha.Size.Width - 1, plocha.Size.Height - 1);

                if (plocha.Image != null)
                    g.DrawImage(plocha.Image, 0, 0);

                plocha.Image = b;
                // plocha.Invalidate();

            }
            statusLabel1.Text = plocha.Width + "x" + plocha.Height;
        }
    }
}
